clear all;
close all;
num_points = 1023; %-1
t_max = 16;
t = [0: t_max/num_points:t_max];
to = max(t)/2;

sigma = 2/4;
g = (1/sqrt(2*sigma^2*pi))*exp(-((t-to).^2)/(2*sigma^2));

hold;
plot(t,g,'b');
a2 = sum(g*t_max/num_points)
norm(g)
g2=g/norm(g);
plot(t,g2,'k');

figure;
alpha=1/(8*t_max); beta=11/3; omega=4;
s= (alpha/pi)^(1/4) * exp(-alpha*t.^2 + sqrt(-1)*beta*t.^2 + sqrt(-1)*omega*t);
s = 10*s/norm(s);
subplot(2,1,1);
plot(t,real(s));
subplot(2,1,2);
plot(t,imag(s));

for i = -length(t)/2:1:length(t)/2-1,
    i

    g = (1/sqrt(2*sigma^2*pi))*exp((-(t-t(i+length(t)/2+1)).^2)/(2*sigma^2));

    sg= s.*g; 

%    sg= s.*(circshift(g',i)');
    fp1 = fft(sg);
    psd(length(t)/2+i+1,:) = abs(fp1(1:length(fp1)/2));
end;

figure;
image(psd');

% figure;
f_ind = [0:1/((num_points+1)/2-1):1];
% surf(t,f_ind,psd');
% xlabel('Time')
% ylabel('Normalized Frequency f/F_s ')
% 
figure;
image(t,f_ind,psd');
xlabel('Time')
ylabel('Normalized Frequency f/F_s')
colorbar;

figure;
contour(t,f_ind,psd',16);
xlabel('Time')
ylabel('Normalized Frequency f/F_s')
colorbar;