close all;
clear all;
full_size=511;
half_size=floor(full_size/2);

han = hann(full_size);
han = han/norm(han);
han0 = han/han(half_size+1);
ham = hamming(full_size);
ham = ham/norm(ham)
ham0 = ham/ham(half_size+1);
k = kaiser(full_size);
k = k/norm(k);
k0 = k/k(half_size+1);
g = exp(-([-half_size:half_size]./100).^2);
g=g/norm(g);
g0 = g/g(half_size+1);
b = blackman(full_size);
b = b/norm(b);
b0 = b/b(half_size+1);
t = triang(full_size);
t = t/norm(t);
t0 = t/t(half_size+1);
r = rectwin(full_size)
r = r/norm(r);
r0 = r/r(half_size+1);
s = sinc(([-half_size:half_size]/1000));
s = s/norm(s);
s0 = s/s(half_size+1);

figure;
subplot(3,1,1)
hold;
plot([-half_size:half_size]./full_size, s,'b')
plot([-half_size:half_size]./full_size, r,'r')
plot([-half_size:half_size]./full_size, t,'g')
plot([-half_size:half_size]./full_size, b,'k')
plot([-half_size:half_size]./full_size, k,'m')
plot([-half_size:half_size]./full_size, ham,'c')
plot([-half_size:half_size]./full_size, han,'y')
plot([-half_size:half_size]./full_size, g,'r--');
title('Windows with |g(t)|=1');
legend('Sinc', 'Rectangular', 'Triangular', 'Blackman', 'Kaiser', 'Hamming', 'Hann', 'Gaussian');


subplot(3,1,2)
hold;
plot([-half_size:half_size]./full_size, s0,'b')
plot([-half_size:half_size]./full_size, r0,'r')
plot([-half_size:half_size]./full_size, t0,'g')
plot([-half_size:half_size]./full_size, b0,'k')
plot([-half_size:half_size]./full_size, k0,'m')
plot([-half_size:half_size]./full_size, ham0,'c')
plot([-half_size:half_size]./full_size, han0,'y')
plot([-half_size:half_size]./full_size, g0,'r--')
title('Windows with g(0)=1');
legend('Sinc', 'Rectangular', 'Triangular', 'Blackman', 'Kaiser', 'Hamming', 'Hann', 'Gaussian');

full_size=1023-full_size+1;
half_size=floor(full_size/2);
impulse=zeros(full_size,1);
impulse(half_size+1) = 1;


s=conv(s,impulse);
r=conv(r,impulse);
t=conv(t,impulse);
b=conv(b,impulse);
k=conv(k,impulse);
ham=conv(ham,impulse);
han=conv(han,impulse);
g=conv(g,impulse);

full_size=length(s);
half_size=floor(full_size/2);

subplot(3,1,3)
hold;
plot([-half_size:half_size]./full_size, s,'b')
plot([-half_size:half_size]./full_size, r,'r')
plot([-half_size:half_size]./full_size, t,'g')
plot([-half_size:half_size]./full_size, b,'k')
plot([-half_size:half_size]./full_size, k,'m')
plot([-half_size:half_size]./full_size, ham,'c')
plot([-half_size:half_size]./full_size, han,'y')
plot([-half_size:half_size]./full_size, g,'r--');
title('Windows with |g(t)|=1');
legend('Sinc', 'Rectangular', 'Triangular', 'Blackman', 'Kaiser', 'Hamming', 'Hann', 'Gaussian');

