%close all;
clear all;
full_size=511;
half_size=floor(full_size/2);

han = hann(full_size);
han = han/norm(han);
han0 = han/han(half_size+1);
ham = hamming(full_size);
ham = ham/norm(ham)
ham0 = ham/ham(half_size+1);
k = kaiser(full_size);
k = k/norm(k);
k0 = k/k(half_size+1);
g = exp(-([-half_size:half_size]./100).^2);
g=g/norm(g);
g0 = g/g(half_size+1);
b = blackman(full_size);
b = b/norm(b);
b0 = b/b(half_size+1);
t = triang(full_size);
t = t/norm(t);
t0 = t/t(half_size+1);
r = rectwin(full_size)
r = r/norm(r);
r0 = r/r(half_size+1);
s = sinc(([-half_size:half_size]/1000));
s = s/norm(s);
s0 = s/s(half_size+1);

% figure;
% subplot(2,2,1)
% hold;
% plot([-half_size:half_size]./full_size, s,'b')
% plot([-half_size:half_size]./full_size, r,'r')
% plot([-half_size:half_size]./full_size, t,'g')
% plot([-half_size:half_size]./full_size, b,'k')
% plot([-half_size:half_size]./full_size, k,'m')
% plot([-half_size:half_size]./full_size, ham,'c')
% plot([-half_size:half_size]./full_size, han,'y')
% plot([-half_size:half_size]./full_size, g,'r--');
% title('Windows with |g(t)=1|');
% legend('Sinc', 'Rectangular', 'Triangular', 'Blackman', 'Kaiser', 'Hamming', 'Hann', 'Gaussian');
% 
% 
% subplot(2,2,2)
% hold;
% plot([-half_size:half_size]./full_size, s0,'b')
% plot([-half_size:half_size]./full_size, r0,'r')
% plot([-half_size:half_size]./full_size, t0,'g')
% plot([-half_size:half_size]./full_size, b0,'k')
% plot([-half_size:half_size]./full_size, k0,'m')
% plot([-half_size:half_size]./full_size, ham0,'c')
% plot([-half_size:half_size]./full_size, han0,'y')
% plot([-half_size:half_size]./full_size, g0,'r--')
% title('Windows with g(0)=1');
% legend('Sinc', 'Rectangular', 'Triangular', 'Blackman', 'Kaiser', 'Hamming', 'Hann', 'Gaussian');

full_size=8191-full_size+1;
half_size=floor(full_size/2);
impulse=zeros(full_size,1);
impulse(half_size+1) = 1;


s=conv(s,impulse);
r=conv(r,impulse);
t=conv(t,impulse);
b=conv(b,impulse);
k=conv(k,impulse);
ham=conv(ham,impulse);
han=conv(han,impulse);
g=conv(g,impulse);

full_size=length(s);
half_size=floor(full_size/2);


%subplot(2,2,3)
%hold;
sf = fftshift(fft(s))/sqrt(full_size);
%sf = fft(s);
%plot(10*log10(abs(sf)),'b')
rf = fftshift(fft(r))/sqrt(full_size);
%rf = fft(r);
%plot(10*log10(abs(rf)),'r')
tf = fftshift(fft(t))/sqrt(full_size);
%tf = fft(t);
%plot(10*log10(abs(tf)),'g')
bf = fftshift(fft(b))/sqrt(full_size);
%bf = fft(b);
%plot(10*log10(abs(bf)),'k')
kf = fftshift(fft(k))/sqrt(full_size);
%kf = fft(k);
%plot(10*log10(abs(kf)),'m')
hamf = fftshift(fft(ham))/sqrt(full_size);
%hamf = fft(ham);
%plot(10*log10(abs(hamf)),'c')
hanf = fftshift(fft(han))/sqrt(full_size);
%hanf = fft(han);
%plot(10*log10(abs(hanf)),'y')
gf = fftshift(fft(g))/sqrt(full_size);
%gf = fft(g);
%plot(10*log10(abs(gf)),'r--')
%title('Frequency Response');
%legend('Sinc', 'Rectangular', 'Triangular', 'Blackman', 'Kaiser', 'Hamming', 'Hann', 'Gaussian');

figure;

subplot(2,2,1)
hold;
plot([-half_size:half_size],10*log10(abs(sf)),'b')
plot([-half_size:half_size],10*log10(abs(rf)),'r')
plot([-half_size:half_size],10*log10(abs(tf)),'g')
plot([-half_size:half_size],10*log10(abs(bf)),'k')
plot([-half_size:half_size],10*log10(abs(kf)),'m')
plot([-half_size:half_size],10*log10(abs(hamf)),'c')
plot([-half_size:half_size],10*log10(abs(hanf)),'y')
plot([-half_size:half_size],10*log10(abs(gf)),'r--')

title('Frequency Response');
legend('Sinc', 'Rectangular', 'Triangular', 'Blackman', 'Kaiser', 'Hamming', 'Hann', 'Gaussian','Location','SouthWest');

subplot(2,2,2)
hold;
plot([-half_size:half_size],10*log10(abs(sf)),'b')
plot([-half_size:half_size],10*log10(abs(rf)),'r')
plot([-half_size:half_size],10*log10(abs(tf)),'g')
plot([-half_size:half_size],10*log10(abs(bf)),'k')
plot([-half_size:half_size],10*log10(abs(kf)),'m')
plot([-half_size:half_size],10*log10(abs(hamf)),'c')
plot([-half_size:half_size],10*log10(abs(hanf)),'y')
plot([-half_size:half_size],10*log10(abs(gf)),'r--')

title('Frequency Response');
legend('Sinc', 'Rectangular', 'Triangular', 'Blackman', 'Kaiser', 'Hamming', 'Hann', 'Gaussian','Location','SouthWest');

axis([-50  50 -100 0])


% subplot(3,1,2)
% hold;
% plot(log10([-half_size:half_size]),10*log10(abs(sf)),'b')
% plot(log10([-half_size:half_size]),10*log10(abs(rf)),'r')
% plot(log10([-half_size:half_size]),10*log10(abs(tf)),'g')
% plot(log10([-half_size:half_size]),10*log10(abs(bf)),'k')
% plot(log10([-half_size:half_size]),10*log10(abs(kf)),'m')
% plot(log10([-half_size:half_size]),10*log10(abs(hamf)),'c')
% plot(log10([-half_size:half_size]),10*log10(abs(hanf(half_size+1:full_size))),'y')
% plot(log10([-half_size:half_size]),10*log10(abs(gf(half_size+1:full_size))),'r--')

title('Frequency Response');
legend('Sinc', 'Rectangular', 'Triangular', 'Blackman', 'Kaiser', 'Hamming', 'Hann', 'Gaussian','Location','SouthWest');


%h= axes('position', [0.6 0.2 0.8 0.4])
subplot(2,2,3)
plot(log10([0:half_size]),10*log10(abs(sf(half_size+1:full_size))),'b')
hold;
plot(log10([0:half_size]),10*log10(abs(rf(half_size+1:full_size))),'r')
plot(log10([0:half_size]),10*log10(abs(tf(half_size+1:full_size))),'g')
plot(log10([0:half_size]),10*log10(abs(bf(half_size+1:full_size))),'k')
plot(log10([0:half_size]),10*log10(abs(kf(half_size+1:full_size))),'m')
plot(log10([0:half_size]),10*log10(abs(hamf(half_size+1:full_size))),'c')
plot(log10([0:half_size]),10*log10(abs(hanf(half_size+1:full_size))),'y')
plot(log10([0:half_size]),10*log10(abs(gf(half_size+1:full_size))),'r--')
title('Frequency Response');
legend('Sinc', 'Rectangular', 'Triangular', 'Blackman', 'Kaiser', 'Hamming', 'Hann', 'Gaussian','Location','SouthWest');

%axis([0 1 -50 0]);



subplot(2,2,4)
plot(log10([0:half_size]),10*log10(abs(sf(half_size+1:full_size))),'b')
hold;
plot(log10([0:half_size]),10*log10(abs(rf(half_size+1:full_size))),'r')
plot(log10([0:half_size]),10*log10(abs(tf(half_size+1:full_size))),'g')
plot(log10([0:half_size]),10*log10(abs(bf(half_size+1:full_size))),'k')
plot(log10([0:half_size]),10*log10(abs(kf(half_size+1:full_size))),'m')
plot(log10([0:half_size]),10*log10(abs(hamf(half_size+1:full_size))),'c')
plot(log10([0:half_size]),10*log10(abs(hanf(half_size+1:full_size))),'y')
plot(log10([0:half_size]),10*log10(abs(gf(half_size+1:full_size))),'r--')
title('Frequency Response');
legend('Sinc', 'Rectangular', 'Triangular', 'Blackman', 'Kaiser', 'Hamming', 'Hann', 'Gaussian','Location','SouthWest');

axis([0 2 -80 0]);


